# Configure paths for libogg
# Jack Moffitt <jack@icecast.org> 10-21-2000
# updated by Karl Heyes 31-Mar-2003
# Shamelessly stolen from Owen Taylor and Manish Singh

dnl AM_PATH_OGG([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl Test for libogg, and define OGG_CFLAGS and OGG_LIBS
dnl
AC_DEFUN(AM_PATH_OGG,
[dnl 
AC_ARG_ENABLE(oggtest,
    AC_HELP_STRING([--disable-oggtest],
                   [Do not try to compile and run a test Ogg program]),
   enable_oggtest="$enableval",
   enable_oggtest=yes
)
AC_ARG_VAR([OGG_PREFIX],[path to ogg installation])
AC_ARG_WITH(ogg,
    [AC_HELP_STRING([--with-ogg=PREFIX],
                   [Prefix where libogg is installed (optional)])],
    ogg_prefix="$withval",
    ogg_prefix="$OGG_PREFIX"
)
if test "x$ogg_prefix" != "x" ; then
    OGG_CFLAGS="-I$ogg_prefix/include"
    OGG_LIBS="-L$ogg_prefix/lib"
elif test "x$prefix" != "xNONE"; then
    OGG_CFLAGS="-I$prefix/include"
    OGG_LIBS="-L$prefix/lib"
fi

OGG_LIBS="$OGG_LIBS -logg"

if test "x$enable_oggtest" = "xyes" ; then
    AC_MSG_RESULT([checking for Ogg])
    ac_save_CFLAGS="$CFLAGS"
    ac_save_LIBS="$LIBS"
    CFLAGS="$CFLAGS $OGG_CFLAGS"
    LIBS="$LIBS $OGG_LIBS"
dnl
dnl Now check if the installed Ogg is sufficiently new.
dnl
    AC_CHECK_LIB(ogg, ogg_sync_init,,
        [AC_MSG_RESULT(no)
         AC_TRY_LINK([#include <ogg/ogg.h>],
                     [return 0;], 
            [AC_MSG_ERROR([The test program compiled, but did not run. check config.log])],
            [AC_MSG_ERROR([The test program failed to compile or link. check config.log])]
         )
         OGG_CFLAGS=""
         OGG_LIBS=""
         ifelse([$2], , :, [$2])
        ]
    )
    CFLAGS="$ac_save_CFLAGS"
    LIBS="$ac_save_LIBS"
fi
AC_SUBST(OGG_CFLAGS)
AC_SUBST(OGG_LIBS)
])
