# Configure paths for libvorbis
# Jack Moffitt <jack@icecast.org> 10-21-2000
# updated by Karl Heyes 31-Mar-2003
# Shamelessly stolen from Owen Taylor and Manish Singh

dnl AM_PATH_VORBIS([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl Test for libvorbis, and define VORBIS_CFLAGS and VORBIS_LIBS
dnl
AC_DEFUN(AM_PATH_VORBIS,
[dnl 
dnl Get the cflags and libraries
dnl
AC_ARG_ENABLE(vorbistest,
    AC_HELP_STRING([--disable-vorbistest],
                   [Do not try to compile and run a test Vorbis program]),
   enable_vorbistest="$enableval",
   enable_vorbistest="yes"
)

AC_ARG_VAR([VORBIS_PREFIX],[path to vorbis installation])
AC_ARG_WITH(vorbis,
    AC_HELP_STRING([--with-vorbis=PREFIX],
                   [Prefix where libvorbis is installed (optional)]),
   vorbis_prefix="$withval",
   vorbis_prefix="$VORBIS_PREFIX"
)

if test "x$vorbis_prefix" != "x" ; then
    VORBIS_CFLAGS="-I$vorbis_prefix/include"
    VORBIS_LIBDIR="-L$vorbis_prefix/lib"
elif test "x$prefix" != "xNONE"; then
    VORBIS_CFLAGS="-I$prefix/include"
    VORBIS_LIBDIR="-L$prefix/lib"
fi

VORBIS_LIBS="$VORBIS_LIBDIR -lvorbis -lm"
VORBISFILE_LIBS="-lvorbisfile"
VORBISENC_LIBS="-lvorbisenc"

if test "x$enable_vorbistest" = "xyes" ; then
    AC_MSG_RESULT(checking for Vorbis)

    dnl
    dnl Now check if the installed Vorbis is sufficiently new.
    dnl
    ac_save_CFLAGS="$CFLAGS"
    ac_save_LIBS="$LIBS"
    CFLAGS="$CFLAGS $VORBIS_CFLAGS"
    LIBS="$LIBS $VORBIS_LIBS $OGG_LIBS"
    AC_CHECK_TYPES([struct ovectl_ratemanage_arg],
        vorbis_ok=yes,
        vorbis_ok=no,[
#include <vorbis/codec.h>
#include <vorbis/vorbisenc.h>
])

    if test "x$vorbis_ok" = "xyes" ; then
        ifelse([$1], , :, [$1])     
    else
        ifelse([$2], , :, [$2])     
    fi
    CFLAGS="$ac_save_CFLAGS"
    LIBS="$ac_save_LIBS"
    AC_SUBST(VORBIS_CFLAGS)
    AC_SUBST(VORBIS_LIBS)
    AC_SUBST(VORBISFILE_LIBS)
    AC_SUBST(VORBISENC_LIBS)
fi
])
