/* encode.h
 * - encoding functions
 *
 * Copyright (c) 2001 Michael Smith <msmith@labyrinth.net.au>
 *
 * This program is distributed under the terms of the GNU General
 * Public License, version 2. You may use, modify, and redistribute
 * it under the terms of this license. A copy should be included
 * with this source.
 */

#ifndef __ENCODE_H
#define __ENCODE_H

#include <glib.h>
#include <ogg/ogg.h>
#include <vorbis/codec.h>

typedef struct {
    ogg_stream_state os;
    vorbis_block vb;
    vorbis_dsp_state vd;
    vorbis_info vi;

    gint samples_in_current_page;
    gint samplerate;
    ogg_int64_t prevgranulepos;
    gint in_header;
} encoder_state;

encoder_state *encode_initialise(gint channels, gint rate, gint managed,
    gint min_br, gint nom_br, gint max_br, gfloat quality,
    gint serial, vorbis_comment *vc);
void encode_clear(encoder_state *s);
void encode_data_float(encoder_state *s, gfloat **pcm, gint samples);
int encode_dataout(encoder_state *s, ogg_page *og);
void encode_finish(encoder_state *s);
int encode_flush(encoder_state *s, ogg_page *og);

#endif

