/* gui.h
 * - configuration window functions
 *
 * Copyright (c) 2003 Juho Vh-Herttua <juhovh@iki.fi>
 *
 * This program is distributed under the terms of the GNU General
 * Public License, version 2. You may use, modify, and redistribute
 * it under the terms of this license. A copy should be included
 * with this source.
 */

#ifndef __GUI_H
#define __GUI_H

#include <gtk/gtk.h>
#include "oggcaster.h"

typedef struct {
    oc_state_info *state;
    
    gint managed;
    GtkWidget *quality_button;
    GtkObject *quality_adjustment;
    GtkWidget *bitrate_button;
    GtkWidget *bitrate_min_entry;
    GtkWidget *bitrate_nom_entry;
    GtkWidget *bitrate_max_entry;
    
    GtkWidget *samplerate_menu;
    GtkWidget *channels_menu;
    gint samplerate;
    gint channels;
    
    GtkWidget *server_entry;
    GtkWidget *port_entry;
    GtkWidget *user_entry;
    GtkWidget *password_entry;
    GtkWidget *mount_entry;
    
    GtkWidget *stream_name_entry;
    GtkWidget *stream_genre_entry;
    GtkWidget *stream_description_entry;
    
    GtkWidget *status_entry;
    GtkWidget *connect_button;
    GtkWidget *apply_button;
    GtkWidget *mute_button;
    GtkWidget *ok_button;
    GtkWidget *cancel_button;
} oc_widgets;

void set_samplerate_cb(GtkWidget *w, gpointer data);
void set_channels_cb(GtkWidget *w, gpointer data);
void connect_button_cb(GtkWidget *w, gpointer data);
void connect_button_activate(gint msgid);
void apply_button_cb(GtkWidget *w, gpointer data);
void mute_button_cb(GtkWidget *w, gpointer data);
void ok_button_cb(GtkWidget *w, gpointer data);

void configure(oc_state_info *state);

void set_values(oc_stream_info *stream);
void get_values(oc_stream_info *stream);

GtkWidget *create_format_frame(void);
GtkWidget *create_encoding_frame(void);
GtkWidget *create_server_frame(void);
GtkWidget *create_info_frame(void);
GtkWidget *create_buttons(void);

#endif
